/*
 * Copyright (C) 2003-2004 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//
// @author Stefano Fornari
// @version $Id: Log.cpp,v 1.5 2004/02/09 08:48:49 ste Exp $
//

#include "common/Log.h"

BOOL Log::debugEnabled = false;
Log LOG = Log(true);

wchar_t logmsg[512];

Log::Log(BOOL reset) {
    logFile = fopen(LOG_NAME, (reset) ? "w+" : "a+");
}

Log::~Log() {
    if (logFile != NULL) {
        fclose(logFile);
    }
}

void Log::error(const wchar_t* msg) {
    printMessage(LOG_ERROR, msg);
}

void Log::info(const wchar_t* msg) {
    printMessage(LOG_INFO, msg);
}

void Log::debug(const wchar_t* msg) {
    if (debugEnabled == TRUE) {
        printMessage(LOG_DEBUG, msg);
    }
}

void Log::setDebug(BOOL enabled) {
    debugEnabled = enabled;
}


BOOL Log::isDebug() {
    return debugEnabled;
}

void Log::printMessage(const wchar_t* level, const wchar_t* msg) {
    if (logFile != NULL) {
        fwprintf(logFile, TEXT("%s - %s\n"), level, msg); fflush(logFile);
    }
}