/*
 * Copyright (C) 2003-2004 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//
// @author Marco Magistrali
// @version $Id: DevDetail.cpp,v 1.0 2004/04/27 11:21:00 magi Exp $
//

#include "spdm/win32/DevDetail.h"
#include "spdm/win32/DevDetailURI.h"
#include "spdm/win32/Win32ManagementNode.h"
#include "common/Log.h"

DevDetail::DevDetail(ManagementNode* node) {

    LOG.debug(TEXT("in DevDetail"));    
    readFromDM(node);  
    devDetailUri = NULL;
    //
    // Instantiate DevDetailURI object
    //
/*
    wchar_t fullName [128];
    wmemset (fullName, 0, 128);
    node->getFullName(fullName, 128);

    if (wcslen(fullName) != 0) {
        wsprintf(fullName, TEXT("%s/%s"), fullName, TEXT("URI"));
        
        ManagementNode* n = node->getChild(fullName);
        if (n != NULL)
            devDetailUri = new DevDetailURI(n);
    }
*/
}

DevDetail::~DevDetail() {
    
    if (devDetailUri != NULL)
        delete devDetailUri;
}


wchar_t* DevDetail::getDevTyp() {
    return devTyp;
}

void DevDetail::setDevTyp(wchar_t* p) {
    wcsncpy(devTyp, p, DIM_DEVTYP);
    devTyp[DIM_DEVTYP -1] = 0;
    
}

wchar_t* DevDetail::getOEM() {
    return OEM;
}

void DevDetail::setOEM(wchar_t* p) {
    wcsncpy(OEM, p, DIM_OEM);
    OEM[DIM_OEM -1] = 0;
    
}

wchar_t* DevDetail::getFwV() {
    return fwV;
}

void DevDetail::setFwV(wchar_t* p) {
    wcsncpy(fwV, p, DIM_FWV);
    fwV[DIM_FWV -1] = 0;
    
}

wchar_t* DevDetail::getSwV() {
    return swV;
}

void DevDetail::setSwV(wchar_t* p) {
    wcsncpy(swV, p, DIM_SWV);
    swV[DIM_SWV -1] = 0;
    
}

wchar_t* DevDetail::getHwV() {
    return hwV;
}

void DevDetail::setHwV(wchar_t* p) {
    wcsncpy(hwV, p, DIM_HWV);
    hwV[DIM_HWV -1] = 0;
    
}

wchar_t* DevDetail::getLrgObj() {
    return lrgObj;
}

void DevDetail::setLrgObj(wchar_t* p) {
    wcsncpy(lrgObj, p, DIM_LRGOBJ);
    lrgObj[DIM_LRGOBJ -1] = 0;
    
}

BOOL DevDetail::readFromDM(ManagementNode* node) {
    
    BOOL ret = FALSE;

    if (node == NULL) {
        lastErrorCode = ERR_INVALID_CONTEXT;
        wsprintf(lastErrorMsg, TEXT("DevDetail node configuration NULL"));
        LOG.error(lastErrorMsg);
        goto finally;
    }
    wchar_t buf[INT_VALUESIZE]; // big enough for everything

    node->getPropertyValue(PROPERTY_DEVTYP, buf, INT_VALUESIZE, FALSE );
    setDevTyp(buf);

    node->getPropertyValue(PROPERTY_OEM,   buf, INT_VALUESIZE, FALSE );
    setOEM(buf);

    node->getPropertyValue(PROPERTY_FWV,   buf, INT_VALUESIZE, FALSE );
    setFwV(buf);

    node->getPropertyValue(PROPERTY_SWV,   buf, INT_VALUESIZE, FALSE );
    setSwV(buf);

    node->getPropertyValue(PROPERTY_HWV,  buf, INT_VALUESIZE, FALSE );
    setHwV(buf);

    node->getPropertyValue(PROPERTY_LRGOBJ,  buf, INT_VALUESIZE, FALSE );
    setLrgObj(buf);
    
    if (lastErrorCode != 0) {
        wsprintf(lastErrorMsg, TEXT("DevDetail configuration not found"));
        LOG.error(lastErrorMsg);
        goto finally;
    }

    ret = TRUE;
    
finally:
    return FALSE;

}

