/*
 * Copyright (C) 2003-2004 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 #ifndef INCL_DEVICE_MANAGER_UTIL_SPDM
    #define INCL_DEVICE_MANAGER_UTIL_SPDM

    #include "common/fscapi.h"
    #include "ptypes/ptypes.h"
    
    USING_PTYPES
    /*
     * Extracts the node name from the node path
     *
     * @param node - the node path
     * @param name - the buffer that will contain the node name
     * @param size - buffer size
     */
    void getNodeName(const wchar_t* node, wchar_t* name, int size);

    /*
     * Extracts the node context from the node path
     *
     * @param node - the node path
     * @param context - the buffer that will contain the node context
     * @param size - buffer size
     */
    void getNodeContext(const wchar_t* node, wchar_t* context, int size);

    /*
    * Function that convert char* to wchar_t*. It creates buffer with new operator
    * and has to be descarded by the caller
    */

    wchar_t* char2wchar(char *token);
 

    /*
    * Function that convert wchar_t* to char*. It creates buffer with new operator
    * and has to be descarded by the caller
    */

    char* wchar2char(wchar_t* wtoken);

    /*
    * Function used to remove xmlns="syncml:metinf" or xmlns="syncml:SYNCML1.1" from tags of xml msg.
    * suppose tag with name space is like <Type xmlns="syncml:metinf"> or <SyncML xmlns="syncml:SYNCML1.1">
    */

    wchar_t* removeNameSpace(wchar_t* wtoken);


#endif