/*
 * Copyright (C) 2003-2004 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INCL_DM_DEVDETAILURI
    #define INCL_DM_DEVDETAILURI

    #include "http/common/Constants.h"
    #include "spds/common/Constants.h"    
    #include "spdm/common/Constants.h"
    #include "spdm/common/ManagementNode.h"

    #define PROPERTY_MAXDEPTH       TEXT("MaxDepth"   )
    #define PROPERTY_MAXTOTLEN      TEXT("MaxTotLen"  )
    #define PROPERTY_MAXSEGLEN      TEXT("MaxSegLen"  )   
    
    #define INT_VALUESIZE         512
    
    class __declspec(dllexport) DevDetailURI {

    private:

        wchar_t maxDepth      [DIM_MAXDEPTH  ];
        wchar_t maxTotLen     [DIM_MAXTOTLEN ];
        wchar_t maxSegLen     [DIM_MAXSEGLEN ];

    public:
        DevDetailURI();
        DevDetailURI(ManagementNode* node);

        wchar_t* getMaxDepth();
        void setMaxDepth(wchar_t*  maxDepth );

        wchar_t* getMaxTotLen();
        void setMaxTotLen(wchar_t* maxTotLen);

        wchar_t* getMaxSegLen();
        void setMaxSegLen(wchar_t* maxSegLen);
  
        /*
         * Reads the configuration from the device manager
         */
        BOOL readFromDM(ManagementNode* node);

    };
#endif