/*
 * Copyright (C) 2003-2004 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//
// @author Marco Magistrali
// @version $Id: SyncMLDMConfig.cpp,v 1.0 2004/04/27 11:21:00 magi Exp $
//
#ifndef INCL_DM_SYNCMLDMACC
    #define INCL_DM_SYNCMLDMACC

    #include "http/common/Constants.h"
    #include "spds/common/Constants.h"    
    #include "spdm/common/Constants.h"
    #include "spdm/common/ManagementNode.h"
    #include "spdm/common/ManagementTree.h"
    #include "common/Log.h"

    #define PROPERTY_USER         TEXT("UserName")
    #define PROPERTY_CLIENTPW     TEXT("ClientPW")
    #define PROPERTY_ADDR         TEXT("Addr")
    #define PROPERTY_ADDRTYPE     TEXT("AddrType")
    #define PROPERTY_PORTNUMBER   TEXT("PortNUmber")
    #define PROPERTY_SERVERID     TEXT("ServerId")
    #define PROPERTY_SERVERPW     TEXT("ServerPW")
    #define PROPERTY_CLIENTNONCE  TEXT("ClientNonce")
    
    
    #define INT_VALUESIZE         512
    
    class __declspec(dllexport) SyncMLDMAcc {

    private:

        wchar_t username      [DIM_USER       ];
        wchar_t clientPW      [DIM_CLIENTPW   ];
        wchar_t addr          [DIM_ADDR       ];
        wchar_t addrType      [DIM_ADDRTYPE   ];
        wchar_t portNumber    [DIM_PORTNUMBER ];
        wchar_t serverId      [DIM_SERVERID   ];
        wchar_t serverPW      [DIM_SERVERPW   ];
        wchar_t clientNonce   [DIM_CLIENTNONCE];
        
        
        

    public:
        SyncMLDMAcc();
        SyncMLDMAcc(ManagementNode* node);              


        wchar_t* getUsername();
        void setUsername(wchar_t* username);

        wchar_t* getClientPW();
        void setClientPW(wchar_t* clientPW);

        wchar_t* getAddr();
        void setAddr(wchar_t* addr);

        wchar_t* getAddrType();
        void setAddrType(wchar_t* addrType);

        wchar_t* getPortNumber();
        void setPortNumber(wchar_t* portNumber);
        
        wchar_t* getServerId();
        void setServerId(wchar_t* serverId);

        wchar_t* getServerPW();
        void setServerPW(wchar_t* serverPW);

        wchar_t* getClientNonce();
        void setClientNonce(wchar_t* clientNonce);
     
        /*
         * Reads the configuration from the device manager
         */
        BOOL readFromDM(ManagementNode* node);

        /*
         * Stores the changed information into the device manager.
         * It returns TRUE if the operation was successfull, FALSE otherwise.
         *
         * NOTE: this methods must be mainly developed. For now it stores the sources
         *       last timestamp only. Is TBD to trace which fields are changed and
         *       persists them in the DM as well.
         */
        BOOL saveToDM(ManagementTree* mt, wchar_t* nameDMAcc);

    };
#endif